Temporary fix for hspace's NPU calculation
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN = $(top_srcdir)/autotools/check-man
26 CHECK_VERSION = $(top_srcdir)/autotools/check-version
27 CHECK_NEWS = $(top_srcdir)/autotools/check-news
28 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
29 DOCPP = $(top_srcdir)/autotools/docpp
30 REPLACE_VARS_SED = autotools/replace_vars.sed
31 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
32 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
33
34 # Note: these are automake-specific variables, and must be named after
35 # the directory + 'dir' suffix
36 clientdir = $(pkgpythondir)/client
37 hypervisordir = $(pkgpythondir)/hypervisor
38 httpdir = $(pkgpythondir)/http
39 masterddir = $(pkgpythondir)/masterd
40 confddir = $(pkgpythondir)/confd
41 rapidir = $(pkgpythondir)/rapi
42 serverdir = $(pkgpythondir)/server
43 watcherdir = $(pkgpythondir)/watcher
44 impexpddir = $(pkgpythondir)/impexpd
45 utilsdir = $(pkgpythondir)/utils
46 toolsdir = $(pkglibdir)/tools
47 iallocatorsdir = $(pkglibdir)/iallocators
48 pytoolsdir = $(pkgpythondir)/tools
49 docdir = $(datadir)/doc/$(PACKAGE)
50
51 # Delete output file if an error occurred while building it
52 .DELETE_ON_ERROR:
53
54 HTOOLS_DIRS = \
55         htools \
56         htools/Ganeti \
57         htools/Ganeti/HTools \
58         htools/Ganeti/HTools/Program
59
60 DIRS = \
61         autotools \
62         daemons \
63         devel \
64         doc \
65         doc/examples \
66         doc/examples/hooks \
67         doc/examples/gnt-debug \
68         $(HTOOLS_DIRS) \
69         lib \
70         lib/client \
71         lib/build \
72         lib/confd \
73         lib/http \
74         lib/hypervisor \
75         lib/impexpd \
76         lib/masterd \
77         lib/rapi \
78         lib/server \
79         lib/tools \
80         lib/utils \
81         lib/watcher \
82         man \
83         qa \
84         test \
85         test/data \
86         test/data/ovfdata \
87         test/data/ovfdata/other \
88         tools
89
90 BUILDTIME_DIR_AUTOCREATE = \
91         scripts \
92         $(APIDOC_DIR) \
93         $(APIDOC_PY_DIR) \
94         $(APIDOC_HS_DIR) \
95         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
96         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
97         $(COVERAGE_DIR) \
98         $(COVERAGE_PY_DIR) \
99         $(COVERAGE_HS_DIR) \
100         .hpc
101
102 BUILDTIME_DIRS = \
103         $(BUILDTIME_DIR_AUTOCREATE) \
104         doc/html
105
106 DIRCHECK_EXCLUDE = \
107         $(BUILDTIME_DIRS) \
108         ganeti-[0-9]*.[0-9]*.[0-9]* \
109         doc/html/_*
110
111 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
112
113 # some helper vars
114 COVERAGE_DIR = doc/coverage
115 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
116 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
117 APIDOC_DIR = doc/api
118 APIDOC_PY_DIR = $(APIDOC_DIR)/py
119 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
120
121 MAINTAINERCLEANFILES = \
122         $(docpng) \
123         $(maninput) \
124         doc/install-quick.rst \
125         doc/news.rst \
126         doc/upgrade.rst \
127         vcs-version
128
129 maintainer-clean-local:
130         rm -rf $(BUILDTIME_DIRS)
131
132 CLEANFILES = \
133         $(addsuffix /*.py[co],$(DIRS)) \
134         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
135         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
136         $(all_dirfiles) \
137         $(PYTHON_BOOTSTRAP) \
138         epydoc.conf \
139         autotools/replace_vars.sed \
140         daemons/daemon-util \
141         daemons/ganeti-cleaner \
142         devel/upload \
143         $(BUILT_EXAMPLES) \
144         doc/examples/bash_completion \
145         lib/_generated_rpc.py \
146         $(man_MANS) \
147         $(manhtml) \
148         tools/kvm-ifup \
149         stamp-srclinks \
150         $(nodist_pkgpython_PYTHON) \
151         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
152         .hpc/*.mix htools/*.tix \
153         doc/hs-lint.html
154
155 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
156 # it'll cause the target to rebuild every time.
157 BUILT_SOURCES = \
158   $(built_base_sources) \
159         $(BUILT_PYTHON_SOURCES) \
160         $(PYTHON_BOOTSTRAP)
161
162 built_base_sources = \
163         ganeti \
164         stamp-srclinks \
165         $(all_dirfiles)
166
167 built_python_base_sources = \
168         lib/_autoconf.py \
169         lib/_vcsversion.py
170
171 BUILT_PYTHON_SOURCES = \
172         $(built_python_base_sources) \
173         lib/_generated_rpc.py
174
175 # Generating the RPC wrappers depends on many things, so make sure it's built at
176 # the end of the built sources
177 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
178
179 # these are all built from the underlying %.in sources
180 BUILT_EXAMPLES = \
181         doc/examples/ganeti-kvm-poweroff.initd \
182         doc/examples/ganeti.cron \
183         doc/examples/ganeti.initd \
184         doc/examples/gnt-config-backup \
185         doc/examples/hooks/ipsec
186
187 nodist_pkgpython_PYTHON = \
188         $(BUILT_PYTHON_SOURCES)
189
190 noinst_PYTHON = \
191         lib/build/__init__.py \
192         lib/build/sphinx_ext.py
193
194 pkgpython_PYTHON = \
195         lib/__init__.py \
196         lib/asyncnotifier.py \
197         lib/backend.py \
198         lib/bdev.py \
199         lib/bootstrap.py \
200         lib/cli.py \
201         lib/cmdlib.py \
202         lib/compat.py \
203         lib/config.py \
204         lib/constants.py \
205         lib/daemon.py \
206         lib/errors.py \
207         lib/ht.py \
208         lib/jqueue.py \
209         lib/jstore.py \
210         lib/locking.py \
211         lib/luxi.py \
212         lib/mcpu.py \
213         lib/netutils.py \
214         lib/objects.py \
215         lib/opcodes.py \
216         lib/ovf.py \
217         lib/qlang.py \
218         lib/query.py \
219         lib/rpc.py \
220         lib/rpc_defs.py \
221         lib/runtime.py \
222         lib/serializer.py \
223         lib/ssconf.py \
224         lib/ssh.py \
225         lib/storage.py \
226         lib/uidpool.py \
227         lib/workerpool.py
228
229 client_PYTHON = \
230         lib/client/__init__.py \
231         lib/client/gnt_backup.py \
232         lib/client/gnt_cluster.py \
233         lib/client/gnt_debug.py \
234         lib/client/gnt_group.py \
235         lib/client/gnt_instance.py \
236         lib/client/gnt_job.py \
237         lib/client/gnt_node.py \
238         lib/client/gnt_os.py
239
240 hypervisor_PYTHON = \
241         lib/hypervisor/__init__.py \
242         lib/hypervisor/hv_base.py \
243         lib/hypervisor/hv_chroot.py \
244         lib/hypervisor/hv_fake.py \
245         lib/hypervisor/hv_kvm.py \
246         lib/hypervisor/hv_lxc.py \
247         lib/hypervisor/hv_xen.py
248
249 rapi_PYTHON = \
250         lib/rapi/__init__.py \
251         lib/rapi/baserlib.py \
252         lib/rapi/client.py \
253         lib/rapi/client_utils.py \
254         lib/rapi/connector.py \
255         lib/rapi/rlib2.py
256
257 http_PYTHON = \
258         lib/http/__init__.py \
259         lib/http/auth.py \
260         lib/http/client.py \
261         lib/http/server.py
262
263 confd_PYTHON = \
264         lib/confd/__init__.py \
265         lib/confd/client.py \
266         lib/confd/querylib.py \
267         lib/confd/server.py
268
269 masterd_PYTHON = \
270         lib/masterd/__init__.py \
271         lib/masterd/instance.py
272
273 impexpd_PYTHON = \
274         lib/impexpd/__init__.py
275
276 watcher_PYTHON = \
277         lib/watcher/__init__.py \
278         lib/watcher/nodemaint.py \
279         lib/watcher/state.py
280
281 server_PYTHON = \
282         lib/server/__init__.py \
283         lib/server/confd.py \
284         lib/server/masterd.py \
285         lib/server/noded.py \
286         lib/server/rapi.py
287
288 pytools_PYTHON = \
289         lib/tools/__init__.py \
290         lib/tools/ensure_dirs.py
291
292 utils_PYTHON = \
293         lib/utils/__init__.py \
294         lib/utils/algo.py \
295         lib/utils/filelock.py \
296         lib/utils/hash.py \
297         lib/utils/io.py \
298         lib/utils/log.py \
299         lib/utils/mlock.py \
300         lib/utils/nodesetup.py \
301         lib/utils/process.py \
302         lib/utils/retry.py \
303         lib/utils/text.py \
304         lib/utils/wrapper.py \
305         lib/utils/x509.py
306
307 docrst = \
308         doc/admin.rst \
309         doc/design-2.0.rst \
310         doc/design-2.1.rst \
311         doc/design-2.2.rst \
312         doc/design-2.3.rst \
313         doc/design-htools-2.3.rst \
314         doc/design-2.4.rst \
315         doc/design-2.5.rst \
316         doc/design-draft.rst \
317         doc/design-oob.rst \
318         doc/design-cpu-pinning.rst \
319         doc/design-query2.rst \
320         doc/design-x509-ca.rst \
321         doc/design-http-server.rst \
322         doc/design-impexp2.rst \
323         doc/design-lu-generated-jobs.rst \
324         doc/design-multi-reloc.rst \
325         doc/design-network.rst \
326         doc/design-chained-jobs.rst \
327         doc/design-ovf-support.rst \
328         doc/design-resource-model.rst \
329         doc/cluster-merge.rst \
330         doc/design-shared-storage.rst \
331         doc/design-node-state-cache.rst \
332         doc/design-virtual-clusters.rst \
333         doc/devnotes.rst \
334         doc/glossary.rst \
335         doc/hooks.rst \
336         doc/iallocator.rst \
337         doc/index.rst \
338         doc/install-quick.rst \
339         doc/install.rst \
340         doc/locking.rst \
341         doc/move-instance.rst \
342         doc/news.rst \
343         doc/rapi.rst \
344         doc/security.rst \
345         doc/upgrade.rst \
346         doc/walkthrough.rst
347
348 HS_PROGS = htools/htools
349 HS_BIN_ROLES = hbal hscan hspace
350
351 HS_ALL_PROGS = $(HS_PROGS) htools/test
352 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
353 # we don't add -Werror by default
354 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
355 # extra flags that can be overriden on the command line
356 HEXTRA =
357 # internal extra flags (used for htools/test mainly)
358 HEXTRA_INT =
359 # exclude options for coverage reports
360 HPCEXCL = --exclude Main \
361         --exclude Ganeti.Constants \
362         --exclude Ganeti.THH \
363         --exclude Ganeti.HTools.QC \
364         --exclude Ganeti.HTools.QCHelper \
365         --exclude Ganeti.HTools.Version
366
367 HS_LIB_SRCS = \
368         htools/Ganeti/HTools/CLI.hs \
369         htools/Ganeti/HTools/Cluster.hs \
370         htools/Ganeti/HTools/Compat.hs \
371         htools/Ganeti/HTools/Container.hs \
372         htools/Ganeti/HTools/ExtLoader.hs \
373         htools/Ganeti/HTools/Group.hs \
374         htools/Ganeti/HTools/IAlloc.hs \
375         htools/Ganeti/HTools/Instance.hs \
376         htools/Ganeti/HTools/JSON.hs \
377         htools/Ganeti/HTools/Loader.hs \
378         htools/Ganeti/HTools/Luxi.hs \
379         htools/Ganeti/HTools/Node.hs \
380         htools/Ganeti/HTools/PeerMap.hs \
381         htools/Ganeti/HTools/QC.hs \
382         htools/Ganeti/HTools/QCHelper.hs \
383         htools/Ganeti/HTools/Rapi.hs \
384         htools/Ganeti/HTools/Simu.hs \
385         htools/Ganeti/HTools/Text.hs \
386         htools/Ganeti/HTools/Types.hs \
387         htools/Ganeti/HTools/Utils.hs \
388         htools/Ganeti/HTools/Program.hs \
389         htools/Ganeti/HTools/Program/Hail.hs \
390         htools/Ganeti/HTools/Program/Hbal.hs \
391         htools/Ganeti/HTools/Program/Hscan.hs \
392         htools/Ganeti/HTools/Program/Hspace.hs \
393         htools/Ganeti/BasicTypes.hs \
394         htools/Ganeti/Jobs.hs \
395         htools/Ganeti/Luxi.hs \
396         htools/Ganeti/OpCodes.hs \
397         htools/Ganeti/THH.hs
398
399 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
400 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
401
402 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
403
404 # Note: we use here an order-only prerequisite, as the contents of
405 # _autoconf.py are not actually influencing the html build output: it
406 # has to exist in order for the sphinx module to be loaded
407 # successfully, but we certainly don't want the docs to be rebuilt if
408 # it changes
409 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
410         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
411         | $(BUILT_PYTHON_SOURCES)
412         @test -n "$(SPHINX)" || \
413             { echo 'sphinx-build' not found during configure; exit 1; }
414         @mkdir_p@ $(dir $@)
415         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
416             -d . \
417             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
418             -D release="$(PACKAGE_VERSION)" \
419             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
420         rm -f doc/html/.buildinfo doc/html/objects.inv
421         touch $@
422
423 doc/html: doc/html/index.html
424
425 doc/install-quick.rst: INSTALL
426 doc/news.rst: NEWS
427 doc/upgrade.rst: UPGRADE
428
429 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
430         set -e; \
431         { echo '.. This file is automatically updated at build time from $<.'; \
432           echo '.. Do not edit.'; \
433           echo; \
434           cat $<; \
435         } > $@
436
437 docdot = \
438         doc/arch-2.0.dot \
439         doc/design-2.1-lock-acquire.dot \
440         doc/design-2.1-lock-release.dot
441
442 docpng = $(patsubst %.dot,%.png,$(docdot))
443
444 # Things to build but not to install (add it to EXTRA_DIST if it should be
445 # distributed)
446 noinst_DATA = \
447         devel/upload \
448         doc/html \
449         $(BUILT_EXAMPLES) \
450         doc/examples/bash_completion \
451         $(manhtml)
452
453 gnt_scripts = \
454         scripts/gnt-backup \
455         scripts/gnt-cluster \
456         scripts/gnt-debug \
457         scripts/gnt-group \
458         scripts/gnt-instance \
459         scripts/gnt-job \
460         scripts/gnt-node \
461         scripts/gnt-os
462
463 PYTHON_BOOTSTRAP_SBIN = \
464         daemons/ganeti-confd \
465         daemons/ganeti-masterd \
466         daemons/ganeti-noded \
467         daemons/ganeti-watcher \
468         daemons/ganeti-rapi \
469         $(gnt_scripts)
470
471 PYTHON_BOOTSTRAP = \
472         $(PYTHON_BOOTSTRAP_SBIN) \
473         tools/ensure-dirs
474
475 qa_scripts = \
476         qa/ganeti-qa.py \
477         qa/qa_cluster.py \
478         qa/qa_config.py \
479         qa/qa_daemon.py \
480         qa/qa_env.py \
481         qa/qa_error.py \
482         qa/qa_group.py \
483         qa/qa_instance.py \
484         qa/qa_node.py \
485         qa/qa_os.py \
486         qa/qa_rapi.py \
487         qa/qa_tags.py \
488         qa/qa_utils.py
489
490 bin_SCRIPTS =
491 if WANT_HTOOLS
492 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
493 install-exec-hook:
494         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
495 # FIXME: this is a hardcoded logic, instead of auto-resolving
496         $(LN_S) -f ../../../bin/htools \
497                    $(DESTDIR)$(iallocatorsdir)/hail
498         for role in $(HS_BIN_ROLES); do \
499                 $(LN_S) -f htools \
500                            $(DESTDIR)$(bindir)/$$role ; \
501         done
502 endif
503
504 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
505         @if [ -z "$(HTOOLS)" ]; then \
506           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
507           exit 1; \
508         fi
509         @BINARY=$(@:htools/%=%); \
510         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
511           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
512           exit 1; \
513         fi
514         BINARY=$(@:htools/%=%); $(GHC) --make \
515           $(HFLAGS) \
516           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
517           -osuf $$BINARY.o -hisuf $$BINARY.hi \
518           $(HEXTRA) $(HEXTRA_INT) $@
519
520 # for the htools/test binary, we need to enable profiling/coverage
521 htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
522         -fno-warn-monomorphism-restriction -fno-warn-orphans \
523         -fno-warn-missing-methods -fno-warn-unused-imports
524
525 # rules for building profiling-enabled versions of the haskell
526 # programs: hs-prof does the full two-step build, whereas
527 # hs-prof-quick does only the final rebuild (hs-prof must have been
528 # run before)
529 .PHONY: hs-prof hs-prof-quick
530 hs-prof:
531         $(MAKE) clean
532         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
533         rm -f $(HS_ALL_PROGS)
534         $(MAKE) hs-prof-quick
535
536 hs-prof-quick:
537         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
538
539 dist_sbin_SCRIPTS = \
540         tools/ganeti-listrunner
541
542 nodist_sbin_SCRIPTS = \
543         $(PYTHON_BOOTSTRAP_SBIN) \
544         daemons/ganeti-cleaner
545
546 python_scripts = \
547         tools/burnin \
548         tools/cfgshell \
549         tools/cfgupgrade \
550         tools/cfgupgrade12 \
551         tools/cluster-merge \
552         tools/confd-client \
553         tools/fmtjson \
554         tools/lvmstrap \
555         tools/move-instance \
556         tools/ovfconverter \
557         tools/setup-ssh \
558         tools/sanitize-config
559
560 dist_tools_SCRIPTS = \
561         $(python_scripts) \
562         tools/kvm-console-wrapper \
563         tools/xm-console-wrapper \
564         tools/master-ip-setup
565
566 pkglib_python_scripts = \
567         daemons/import-export \
568         tools/check-cert-expired
569
570 nodist_pkglib_python_scripts = \
571         tools/ensure-dirs
572
573 pkglib_SCRIPTS = \
574         daemons/daemon-util \
575         tools/kvm-ifup \
576         $(pkglib_python_scripts)
577
578 nodist_pkglib_SCRIPTS = \
579         $(nodist_pkglib_python_scripts)
580
581 EXTRA_DIST = \
582         NEWS \
583         UPGRADE \
584         epydoc.conf.in \
585         pylintrc \
586         autotools/build-bash-completion \
587         autotools/build-rpc \
588         autotools/check-header \
589         autotools/check-python-code \
590         autotools/check-imports \
591         autotools/check-man \
592         autotools/check-news \
593         autotools/check-tar \
594         autotools/check-version \
595         autotools/convert-constants \
596         autotools/docpp \
597         autotools/gen-coverage \
598         autotools/testrunner \
599         $(RUN_IN_TEMPDIR) \
600         daemons/daemon-util.in \
601         daemons/ganeti-cleaner.in \
602         $(pkglib_python_scripts) \
603         devel/upload.in \
604         tools/kvm-ifup.in \
605         $(docdot) \
606         $(docpng) \
607         $(docrst) \
608         doc/conf.py \
609         doc/html \
610         $(BUILT_EXAMPLES:%=%.in) \
611         doc/examples/ganeti.default \
612         doc/examples/ganeti.default-debug \
613         doc/examples/hooks/ethers \
614         doc/examples/gnt-debug/README \
615         doc/examples/gnt-debug/delay0.json \
616         doc/examples/gnt-debug/delay50.json \
617         test/lockperf.py \
618         test/testutils.py \
619         test/mocks.py \
620         $(dist_TESTS) \
621         $(TEST_FILES) \
622         man/footer.rst \
623         $(manrst) \
624         $(maninput) \
625         qa/qa-sample.json \
626         $(qa_scripts) \
627         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
628         $(HS_PROG_SRCS) \
629         htools/lint-hints.hs
630
631 man_MANS = \
632         man/ganeti.7 \
633         man/ganeti-cleaner.8 \
634         man/ganeti-confd.8 \
635         man/ganeti-listrunner.8 \
636         man/ganeti-masterd.8 \
637         man/ganeti-noded.8 \
638         man/ganeti-os-interface.7 \
639         man/ganeti-rapi.8 \
640         man/ganeti-watcher.8 \
641         man/gnt-backup.8 \
642         man/gnt-cluster.8 \
643         man/gnt-debug.8 \
644         man/gnt-group.8 \
645         man/gnt-instance.8 \
646         man/gnt-job.8 \
647         man/gnt-node.8 \
648         man/gnt-os.8 \
649         man/hail.1 \
650         man/hbal.1 \
651         man/hscan.1 \
652         man/hspace.1 \
653         man/htools.1
654
655 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
656 manhtml = $(patsubst %.rst,%.html,$(manrst))
657 mangen = $(patsubst %.rst,%.gen,$(manrst))
658 maninput = \
659         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
660         $(patsubst %.html,%.html.in,$(manhtml)) \
661         man/footer.man man/footer.html $(mangen)
662
663 TEST_FILES = \
664         test/data/bdev-drbd-8.0.txt \
665         test/data/bdev-drbd-8.3.txt \
666         test/data/bdev-drbd-disk.txt \
667         test/data/bdev-drbd-net-ip4.txt \
668         test/data/bdev-drbd-net-ip6.txt \
669         test/data/cert1.pem \
670         test/data/ip-addr-show-dummy0.txt \
671         test/data/ip-addr-show-lo-ipv4.txt \
672         test/data/ip-addr-show-lo-ipv6.txt \
673         test/data/ip-addr-show-lo-oneline-ipv4.txt \
674         test/data/ip-addr-show-lo-oneline-ipv6.txt \
675         test/data/ip-addr-show-lo-oneline.txt \
676         test/data/ip-addr-show-lo.txt \
677         test/data/proc_drbd8.txt \
678         test/data/proc_drbd80-emptyline.txt \
679         test/data/proc_drbd83.txt \
680         test/data/proc_drbd83_sync.txt \
681         test/data/proc_drbd83_sync_krnl2.6.39.txt \
682         test/data/kvm_1.0_help.txt \
683         test/data/kvm_0.15.90_help.txt \
684         test/data/kvm_0.12.5_help.txt \
685         test/data/kvm_0.9.1_help.txt \
686         test/data/sys_drbd_usermode_helper.txt \
687         test/data/ovfdata/compr_disk.vmdk.gz \
688         test/data/ovfdata/config.ini \
689         test/data/ovfdata/corrupted_resources.ovf \
690         test/data/ovfdata/empty.ini \
691         test/data/ovfdata/empty.ovf \
692         test/data/ovfdata/ganeti.mf \
693         test/data/ovfdata/ganeti.ovf \
694         test/data/ovfdata/gzip_disk.ovf \
695         test/data/ovfdata/new_disk.vmdk \
696         test/data/ovfdata/no_disk.ini \
697         test/data/ovfdata/no_disk_in_ref.ovf \
698         test/data/ovfdata/no_os.ini \
699         test/data/ovfdata/no_ovf.ova \
700         test/data/ovfdata/ova.ova \
701         test/data/ovfdata/second_disk.vmdk \
702         test/data/ovfdata/rawdisk.raw \
703         test/data/ovfdata/unsafe_path.ini \
704         test/data/ovfdata/virtualbox.ovf \
705         test/data/ovfdata/wrong_extension.ovd \
706         test/data/ovfdata/wrong_config.ini \
707         test/data/ovfdata/wrong_manifest.mf \
708         test/data/ovfdata/wrong_manifest.ovf \
709         test/data/ovfdata/wrong_ova.ova \
710         test/data/ovfdata/wrong_xml.ovf \
711         test/data/ovfdata/other/rawdisk.raw \
712         test/import-export_unittest-helper
713
714 python_tests = \
715         test/ganeti.asyncnotifier_unittest.py \
716         test/ganeti.backend_unittest.py \
717         test/ganeti.bdev_unittest.py \
718         test/ganeti.cli_unittest.py \
719         test/ganeti.client.gnt_cluster_unittest.py \
720         test/ganeti.client.gnt_instance_unittest.py \
721         test/ganeti.daemon_unittest.py \
722         test/ganeti.cmdlib_unittest.py \
723         test/ganeti.compat_unittest.py \
724         test/ganeti.confd.client_unittest.py \
725         test/ganeti.config_unittest.py \
726         test/ganeti.constants_unittest.py \
727         test/ganeti.errors_unittest.py \
728         test/ganeti.hooks_unittest.py \
729         test/ganeti.ht_unittest.py \
730         test/ganeti.http_unittest.py \
731         test/ganeti.hypervisor_unittest.py \
732         test/ganeti.hypervisor.hv_chroot_unittest.py \
733         test/ganeti.hypervisor.hv_fake_unittest.py \
734         test/ganeti.hypervisor.hv_kvm_unittest.py \
735         test/ganeti.hypervisor.hv_lxc_unittest.py \
736         test/ganeti.hypervisor.hv_xen_unittest.py \
737         test/ganeti.impexpd_unittest.py \
738         test/ganeti.jqueue_unittest.py \
739         test/ganeti.locking_unittest.py \
740         test/ganeti.luxi_unittest.py \
741         test/ganeti.masterd.instance_unittest.py \
742         test/ganeti.mcpu_unittest.py \
743         test/ganeti.netutils_unittest.py \
744         test/ganeti.objects_unittest.py \
745         test/ganeti.opcodes_unittest.py \
746         test/ganeti.ovf_unittest.py \
747         test/ganeti.qlang_unittest.py \
748         test/ganeti.query_unittest.py \
749         test/ganeti.rapi.baserlib_unittest.py \
750         test/ganeti.rapi.client_unittest.py \
751         test/ganeti.rapi.resources_unittest.py \
752         test/ganeti.rapi.rlib2_unittest.py \
753         test/ganeti.rpc_unittest.py \
754         test/ganeti.runtime_unittest.py \
755         test/ganeti.serializer_unittest.py \
756         test/ganeti.ssh_unittest.py \
757         test/ganeti.tools.ensure_dirs_unittest.py \
758         test/ganeti.uidpool_unittest.py \
759         test/ganeti.utils.algo_unittest.py \
760         test/ganeti.utils.filelock_unittest.py \
761         test/ganeti.utils.hash_unittest.py \
762         test/ganeti.utils.io_unittest.py \
763         test/ganeti.utils.log_unittest.py \
764         test/ganeti.utils.mlock_unittest.py \
765         test/ganeti.utils.nodesetup_unittest.py \
766         test/ganeti.utils.process_unittest.py \
767         test/ganeti.utils.retry_unittest.py \
768         test/ganeti.utils.text_unittest.py \
769         test/ganeti.utils.wrapper_unittest.py \
770         test/ganeti.utils.x509_unittest.py \
771         test/ganeti.utils_unittest.py \
772         test/ganeti.workerpool_unittest.py \
773         test/cfgupgrade_unittest.py \
774         test/docs_unittest.py \
775         test/pycurl_reset_unittest.py \
776         test/tempfile_fork_unittest.py
777 if HAS_FAKEROOT
778 python_tests += test/ganeti.utils.io_unittest-runasroot.py
779 endif
780
781 haskell_tests = htools/test
782
783 dist_TESTS = \
784         test/check-cert-expired_unittest.bash \
785         test/daemon-util_unittest.bash \
786         test/ganeti-cleaner_unittest.bash \
787         test/import-export_unittest.bash \
788         $(python_tests)
789
790 nodist_TESTS =
791 if WANT_HTOOLSTESTS
792 nodist_TESTS += $(haskell_tests)
793 endif
794
795 TESTS = $(dist_TESTS) $(nodist_TESTS)
796
797 # Environment for all tests
798 PLAIN_TESTS_ENVIRONMENT = \
799         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) \
800         FAKEROOT=$(FAKEROOT_PATH) $(RUN_IN_TEMPDIR)
801
802 # Environment for tests run by automake
803 TESTS_ENVIRONMENT = \
804         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
805
806 all_python_code = \
807         $(dist_sbin_SCRIPTS) \
808         $(python_scripts) \
809         $(pkglib_python_scripts) \
810         $(nodist_pkglib_python_scripts) \
811         $(python_tests) \
812         $(pkgpython_PYTHON) \
813         $(client_PYTHON) \
814         $(hypervisor_PYTHON) \
815         $(rapi_PYTHON) \
816         $(server_PYTHON) \
817         $(pytools_PYTHON) \
818         $(http_PYTHON) \
819         $(confd_PYTHON) \
820         $(masterd_PYTHON) \
821         $(impexpd_PYTHON) \
822         $(utils_PYTHON) \
823         $(watcher_PYTHON) \
824         $(noinst_PYTHON) \
825         $(qa_scripts)
826
827 srclink_files = \
828         man/footer.rst \
829         test/check-cert-expired_unittest.bash \
830         test/daemon-util_unittest.bash \
831         test/ganeti-cleaner_unittest.bash \
832         test/import-export_unittest.bash \
833         $(all_python_code) \
834         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
835
836 check_python_code = \
837         $(BUILD_BASH_COMPLETION) \
838         $(CHECK_IMPORTS) \
839         $(CHECK_HEADER) \
840         $(DOCPP) \
841         $(all_python_code)
842
843 lint_python_code = \
844         ganeti \
845         ganeti/http/server.py \
846         $(dist_sbin_SCRIPTS) \
847         $(python_scripts) \
848         $(pkglib_python_scripts) \
849         $(BUILD_BASH_COMPLETION) \
850         $(CHECK_IMPORTS) \
851         $(CHECK_HEADER) \
852         $(DOCPP) \
853         $(PYTHON_BOOTSTRAP)
854
855 standalone_python_modules = \
856         lib/rapi/client.py \
857         tools/ganeti-listrunner
858
859 pep8_python_code = \
860         ganeti \
861         ganeti/http/server.py \
862         $(dist_sbin_SCRIPTS) \
863         $(python_scripts) \
864         $(pkglib_python_scripts) \
865         $(BUILD_BASH_COMPLETION) \
866         $(CHECK_HEADER) \
867         $(DOCPP) \
868         $(PYTHON_BOOTSTRAP) \
869         qa
870
871 test/daemon-util_unittest.bash: daemons/daemon-util
872
873 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
874
875 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
876         sed -f $(REPLACE_VARS_SED) < $< > $@
877         chmod +x $@
878
879 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
880         sed -f $(REPLACE_VARS_SED) < $< > $@
881         chmod u+x $@
882
883 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
884         sed -f $(REPLACE_VARS_SED) < $< > $@
885         chmod +x $@
886
887 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
888         sed -f $(REPLACE_VARS_SED) < $< > $@
889
890 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
891         sed -f $(REPLACE_VARS_SED) < $< > $@
892
893 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
894         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
895         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
896
897 doc/%.png: doc/%.dot
898         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
899         $(DOT) -Tpng -o $@ $<
900
901 man/footer.man: man/footer.rst
902         @test -n "$(PANDOC)" || \
903           { echo 'pandoc' not found during configure; exit 1; }
904         $(PANDOC) -f rst -t man -o $@ $<
905
906 man/footer.html: man/footer.rst
907         @test -n "$(PANDOC)" || \
908           { echo 'pandoc' not found during configure; exit 1; }
909         $(PANDOC) -f rst -t html -o $@ $<
910
911 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
912         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
913
914 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
915         @test -n "$(PANDOC)" || \
916           { echo 'pandoc' not found during configure; exit 1; }
917         set -o pipefail ; \
918         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
919           sed -e 's/\\@/@/g' > $@
920         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
921
922 man/%.html.in: man/%.gen man/footer.html
923         @test -n "$(PANDOC)" || \
924           { echo 'pandoc' not found during configure; exit 1; }
925         set -o pipefail ; \
926         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
927           sed -e 's/\\@/@/g' > $@
928
929 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
930         sed -f $(REPLACE_VARS_SED) < $< > $@
931
932 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
933         sed -f $(REPLACE_VARS_SED) < $< > $@
934
935 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
936         sed -f $(REPLACE_VARS_SED) < $< > $@
937
938 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
939         sed -f $(REPLACE_VARS_SED) < $< > $@
940
941 epydoc.conf: epydoc.conf.in Makefile
942         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
943
944 vcs-version:
945         if test -d .git; then \
946           git describe > $@; \
947         elif test ! -f $@ ; then \
948           echo "Cannot auto-generate $@ file"; exit 1; \
949         fi
950
951 .PHONY: regen-vcs-version
952 regen-vcs-version:
953         set -e; \
954         cd $(srcdir); \
955         if test -d .git; then \
956           rm -f vcs-version; \
957           $(MAKE) vcs-version; \
958         fi
959
960 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
961         set -e; \
962         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
963         sed -e "s/%ver%/$$VCSVER/" < $< > $@
964
965 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
966         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS) \
967         | lib/_vcsversion.py
968         set -e; \
969         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
970
971 lib/_autoconf.py: Makefile | lib/.dir
972         set -e; \
973         { echo '# This file is automatically generated, do not edit!'; \
974           echo '#'; \
975           echo ''; \
976           echo '"""Build-time configuration for Ganeti.'; \
977           echo '';\
978           echo 'This file is autogenerated by the build process.'; \
979           echo 'For any changes you need to re-run ./configure (and'; \
980           echo 'not edit by hand).'; \
981           echo ''; \
982           echo '"""'; \
983           echo ''; \
984           echo '# pylint: disable=C0301,C0324'; \
985           echo '# because this is autogenerated, we do not want'; \
986           echo '# style warnings' ; \
987           echo ''; \
988           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
989           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
990           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
991           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
992           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
993           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
994           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
995           echo "SYSCONFDIR = '$(sysconfdir)'"; \
996           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
997           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
998           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
999           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1000           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1001           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1002           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1003           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1004           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1005           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1006           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1007           echo "KVM_PATH = '$(KVM_PATH)'"; \
1008           echo "IP_PATH = '$(IP_PATH)'"; \
1009           echo "SOCAT_PATH = '$(SOCAT)'"; \
1010           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1011           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1012           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1013           echo "TOOLSDIR = '$(toolsdir)'"; \
1014           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1015           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1016           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1017           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1018           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1019           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1020           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1021           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1022           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1023           echo "RAPI_USER = '$(RAPI_USER)'"; \
1024           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1025           echo "CONFD_USER = '$(CONFD_USER)'"; \
1026           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1027           echo "NODED_USER = '$(NODED_USER)'"; \
1028           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1029           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1030           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1031           if [ "$(HTOOLS)" ]; then \
1032             echo "HTOOLS = True"; \
1033           else \
1034             echo "HTOOLS = False"; \
1035           fi; \
1036           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1037         } > $@
1038
1039 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1040         set -e; \
1041         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1042         { echo '# This file is automatically generated, do not edit!'; \
1043           echo '#'; \
1044           echo ''; \
1045           echo '"""Build-time VCS version number for Ganeti.'; \
1046           echo '';\
1047           echo 'This file is autogenerated by the build process.'; \
1048           echo 'For any changes you need to re-run ./configure (and'; \
1049           echo 'not edit by hand).'; \
1050           echo ''; \
1051           echo '"""'; \
1052           echo ''; \
1053           echo '# pylint: disable=C0301,C0324'; \
1054           echo '# because this is autogenerated, we do not want'; \
1055           echo '# style warnings' ; \
1056           echo ''; \
1057           echo "VCS_VERSION = '$$VCSVER'"; \
1058         } > $@
1059
1060 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1061         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1062
1063 $(REPLACE_VARS_SED): Makefile
1064         set -e; \
1065         { echo 's#@PREFIX@#$(prefix)#g'; \
1066           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1067           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1068           echo 's#@BINDIR@#$(bindir)#g'; \
1069           echo 's#@SBINDIR@#$(sbindir)#g'; \
1070           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1071           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1072           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1073           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1074           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1075           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1076           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1077           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1078           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1079           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1080           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1081           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1082           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1083           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1084           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1085           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1086           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1087           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1088           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1089         } > $@
1090
1091 # Using deferred evaluation
1092 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1093 daemons/ganeti-watcher: MODULE = ganeti.watcher
1094 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1095 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1096
1097 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1098         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1099         set -e; \
1100         { echo '#!/usr/bin/python'; \
1101           echo '# This file is automatically generated, do not edit!'; \
1102           echo "# Edit $(MODULE) instead."; \
1103           echo; \
1104           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1105           echo; \
1106           echo '# pylint: disable=C0103'; \
1107           echo '# C0103: Invalid name'; \
1108           echo; \
1109           echo 'import sys'; \
1110           echo 'import $(MODULE) as main'; \
1111           echo; \
1112           echo '# Temporarily alias commands until bash completion'; \
1113           echo '# generator is changed'; \
1114           echo 'if hasattr(main, "commands"):'; \
1115           echo '  commands = main.commands # pylint: disable=E1101'; \
1116           echo 'if hasattr(main, "aliases"):'; \
1117           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1118           echo; \
1119           echo 'if __name__ == "__main__":'; \
1120           echo '  sys.exit(main.Main())'; \
1121         } > $@
1122         chmod u+x $@
1123
1124 # We need to create symlinks because "make distcheck" will not install Python
1125 # files when building.
1126 stamp-srclinks: Makefile | $(all_dirfiles)
1127         set -e; \
1128         for i in $(srclink_files); do \
1129                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1130                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1131                 fi; \
1132         done
1133         touch $@
1134
1135 .PHONY: ganeti
1136 ganeti:
1137         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1138
1139 .PHONY: check-dirs
1140 check-dirs: $(BUILT_SOURCES)
1141         @set -e; \
1142         find . -type d \( \( -name . \) -o \( \
1143                 -name .git -o \
1144                 -name autom4te.cache \
1145                 \) -prune -o -print \) | { \
1146                 error=; \
1147                 while read dir; do \
1148                         case "$$dir" in \
1149                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1150                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1151                         esac; \
1152                 done; \
1153                 for dir in $(DIRS); do \
1154                         if ! test -d "$$dir"; then \
1155                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1156                                 error=1; \
1157                         fi \
1158                 done; \
1159                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1160         }
1161
1162 .PHONY: check-local
1163 check-local: check-dirs $(BUILT_SOURCES)
1164         $(CHECK_PYTHON_CODE) $(check_python_code)
1165         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1166         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1167         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1168         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1169         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1170         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1171                 echo "Incorrect version in README, expected $$expver"; \
1172                 exit 1; \
1173         fi; \
1174         for file in doc/iallocator.rst doc/hooks.rst; do \
1175                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1176                         "Documents Ganeti version $$expver"; then \
1177                         echo "Incorrect version in $$file, expected $$expver"; \
1178                         exit 1; \
1179                 fi; \
1180         done
1181
1182 .PHONY: hs-check
1183 hs-check: htools/test
1184         @rm -f test.tix
1185         ./htools/test
1186
1187 # E111: indentation is not a multiple of four
1188 # E261: at least two spaces before inline comment
1189 # E501: line too long (80 characters)
1190 PEP8_IGNORE = E111,E261,E501
1191
1192 # For excluding pep8 expects filenames only, not whole paths
1193 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1194
1195 .PHONY: lint
1196 lint: $(BUILT_SOURCES)
1197         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1198         if test -z "$(PEP8)"; then \
1199                 echo '"pep8" not found during configure' >&2; \
1200         else \
1201                 $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1202                         $(pep8_python_code); \
1203         fi
1204         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1205         cd $(top_srcdir)/qa && \
1206           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1207           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1208
1209 .PHONY: hlint
1210 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1211         if tty -s; then C="-c"; else C=""; fi; \
1212         hlint --report=doc/hs-lint.html --cross $$C \
1213           --ignore "Use first" \
1214           --ignore "Use comparing" \
1215           --ignore "Use on" \
1216           --ignore "Use Control.Exception.catch" \
1217           --ignore "Reduce duplication" \
1218           --hint htools/lint-hints \
1219           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1220
1221 # a dist hook rule for updating the vcs-version file; this is
1222 # hardcoded due to where it needs to build the file...
1223 dist-hook:
1224         $(MAKE) regen-vcs-version && \
1225         rm -f $(top_distdir)/vcs-version && \
1226         cp -p $(srcdir)/vcs-version $(top_distdir)
1227
1228 # a distcheck hook rule for catching revision control directories
1229 distcheck-hook:
1230         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1231                 echo "Found revision control files in final archive." 1>&2; \
1232                 exit 1; \
1233         fi
1234         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1235                 echo "Found Python byte code in final archive." 1>&2; \
1236                 exit 1; \
1237         fi
1238         if find $(top_distdir) -name '*~' | grep .; then \
1239                 echo "Found backup files in final archive." 1>&2; \
1240                 exit 1; \
1241         fi
1242 # Empty files or directories should not be distributed. They can cause
1243 # unnecessary warnings for packagers. Directories used by automake during
1244 # distcheck must be excluded.
1245         if find $(top_distdir) -empty -and -not \( \
1246                         -path $(top_distdir)/_build -or \
1247                         -path $(top_distdir)/_inst \) | grep .; then \
1248                 echo "Found empty files or directories in final archive." 1>&2; \
1249                 exit 1; \
1250         fi
1251         if test -n "$(BUILD_RELEASE)" && \
1252            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1253                 echo "Found unreleased version in NEWS." >&2; \
1254                 exit 1; \
1255         fi
1256
1257 # When building a release, stricter checks should be used
1258 distcheck-release dist-release: export BUILD_RELEASE = 1
1259 distcheck-release: distcheck
1260
1261 dist-release: dist
1262         set -e; \
1263         for i in $(DIST_ARCHIVES); do \
1264                 echo -n "Checking $$i ... "; \
1265                 autotools/check-tar < $$i; \
1266                 echo OK; \
1267         done
1268
1269 install-exec-local:
1270         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1271           "$(DESTDIR)${localstatedir}/log/ganeti" \
1272           "$(DESTDIR)${localstatedir}/run/ganeti"
1273
1274 # To avoid conflicts between directory names and other targets, a file inside
1275 # the directory is used to ensure its existence.
1276 %.dir:
1277         @mkdir_p@ $* && touch $@
1278
1279 .PHONY: apidoc
1280 if WANT_HTOOLSAPIDOC
1281 apidoc: py-apidoc hs-apidoc
1282 else
1283 apidoc: py-apidoc
1284 endif
1285
1286 .PHONY: py-apidoc
1287 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1288         $(RUN_IN_TEMPDIR) epydoc -v \
1289                 --conf $(CURDIR)/epydoc.conf \
1290                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1291
1292 .PHONY: hs-apidoc
1293 hs-apidoc: $(HS_BUILT_SRCS)
1294         @test -n "$(HSCOLOUR)" || \
1295             { echo 'HsColour' not found during configure; exit 1; }
1296         @test -n "$(HADDOCK)" || \
1297             { echo 'haddock' not found during configure; exit 1; }
1298         rm -rf $(APIDOC_HS_DIR)/*
1299         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1300         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1301         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1302         set -e ; \
1303         cd htools; \
1304         if [ "$(HTOOLS_NOCURL)" ]; \
1305         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1306         else OPTGHC=""; \
1307         fi; \
1308         if [ "$(HTOOLS_PARALLEL3)" ]; \
1309         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1310         fi; \
1311         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1312         for file in $$RELSRCS; do \
1313                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1314                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1315         done ; \
1316         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1317                 -t ganeti-htools -p haddock-prologue \
1318                 --source-module="%{MODULE/.//}.html" \
1319                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1320                 $$OPTGHC \
1321                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1322
1323 .PHONY: TAGS
1324 TAGS: $(BUILT_SOURCES)
1325         rm -f TAGS
1326         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1327           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1328           -path './qa/*.py' | \
1329           etags -l python -
1330
1331 .PHONY: coverage
1332 if WANT_HTOOLS
1333 coverage: py-coverage hs-coverage
1334 else
1335 coverage: py-coverage
1336 endif
1337
1338 .PHONY: py-coverage
1339 py-coverage: $(BUILT_SOURCES) $(python_tests)
1340         set -e; \
1341         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1342         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1343         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1344         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1345         $(python_tests)
1346
1347 .PHONY: hs-coverage
1348 hs-coverage: $(haskell_tests)
1349         cd htools && rm -f *.tix *.mix && ./test
1350         @mkdir_p@ $(COVERAGE_HS_DIR)
1351         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1352         hpc report htools/test $(HPCEXCL)
1353         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1354
1355 # Special "kind-of-QA" target for htools, needs special setup (all
1356 # tools compiled with -fhpc)
1357 .PHONY: live-test
1358 live-test: all
1359         set -e ; \
1360         cd htools; \
1361         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1362         rm -f *.tix *.mix; \
1363         ./live-test.sh; \
1364         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1365           --output=live-test.tix ; \
1366         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1367         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1368                 --srcdir=.. $(HPCEXCL) ; \
1369         hpc report --srcdir=.. live-test $(HPCEXCL)
1370
1371 commit-check: distcheck lint apidoc
1372
1373 -include ./Makefile.local
1374
1375 # vim: set noet :